# -*- coding: utf-8 -*-
"""

    Copyright (C) 2018
    Version 1.0.1

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    -------------------------------------------------------------

    Usage Examples:

<dir>
<title>NFL</title>
<frees_nfl>all</frees_nfl>
</dir>

"""    

from __future__ import absolute_import
import requests
import re
import os
import xbmc
import xbmcaddon
from koding import route
from ..plugin import Plugin
from resources.lib.util.context import get_context_items
from resources.lib.util.xml import JenItem, JenList, display_list
from requests.exceptions import HTTPError
import time
from unidecode import unidecode

CACHE_TIME = 3600  # change to wanted cache time in seconds

User_Agent = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36'
addon_fanart = xbmcaddon.Addon().getAddonInfo('fanart')
addon_icon = xbmcaddon.Addon().getAddonInfo('icon')
AddonName = xbmc.getInfoLabel('Container.PluginName')
AddonName = xbmcaddon.Addon(AddonName).getAddonInfo('id')


class frees_nfl(Plugin):
    name = "frees_nfl"

    def process_item(self, item_xml):
        if "<frees_nfl>" in item_xml:
            item = JenItem(item_xml)
            if "all" in item.get("frees_nfl", ""):
                result_item = {
                    'label': item["title"],
                    'icon': item.get("thumbnail", addon_icon),
                    'fanart': item.get("fanart", addon_fanart),
                    'mode': "open_frees_nfl_list",
                    'url': item.get("frees_nfl", ""),
                    'folder': True,
                    'imdb': "0",
                    'season': "0",
                    'episode': "0",
                    'info': {},
                    'year': "0",
                    'context': get_context_items(item),
                    "summary": item.get("summary", None)
                }
                result_item["properties"] = {
                    'fanart_image': result_item["fanart"]
                }
                result_item['fanart_small'] = result_item["fanart"]
                return result_item


@route(mode='open_frees_nfl_list')
def get_link():
    xml = ""
    headers = {'User_Agent':User_Agent}
    url = "http://frees.icu/feed/"
html = requests.get(url).content
match = re.compile("<item>\s.+?>(.+?)\s&.+?source:\s\'(.+?)\'",re.DOTALL).findall(html)
for name, link in match:
    final_link = "%s|Referer=http://frees.icu" % (link)
            xml += "<item>"\
                   "<title>%s</title>"\
                   "<thumbnail></thumbnail>"\
                   "<fanart></fanart>"\
                   "<link>%s</link>"\
                   "</item>" % (name, finl_link)             
        

    jenlist = JenList(xml)
    display_list(jenlist.get_list(), jenlist.get_content_type()) 


def remove_non_ascii(text):
    return unidecode(text)        
            
